/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.tipo_egreso;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.data.SQLiteConnectionHolder;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class SQLiteTipoEgresoDAO implements TipoEgresoDAO {

  private static final Logger log = LogManager.getLogger(SQLiteTipoEgresoDAO.class);
  private ConnectionHolder connectionHolder;

  public SQLiteTipoEgresoDAO() {
    this.connectionHolder = new SQLiteConnectionHolder();
  }

  public SQLiteTipoEgresoDAO(ConnectionHolder connectionHolder) {
    this.connectionHolder = connectionHolder;
  }

  @Override
  public List<TipoEgreso> getAll() {
    log.debug("Se intentara conseguir todos los tipoEgreso");
    List<TipoEgreso> tipoEgresoList = new ArrayList<>();
    String query = "select * from tipos_egreso";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        try (ResultSet rs = ps.executeQuery()) {
          while (rs.next()) {
            TipoEgreso tipoEgreso = new TipoEgreso();
            tipoEgreso.setId(rs.getInt("id"));
            tipoEgreso.setNombre(rs.getString("nombre"));
            tipoEgresoList.add(tipoEgreso);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir todos los tipoEgreso", e);
    }
    log.debug("Se consiguieron " + tipoEgresoList.size() + " TipoEgreso");
    return tipoEgresoList;
  }

  @Override
  public Optional<TipoEgreso> getById(int id) {
    log.debug("Se intentara conseguir un TipoEgreso con id " + id);
    TipoEgreso tipoEgreso = null;
    String query = "select * from tipos_egreso where id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, id);
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            tipoEgreso = new TipoEgreso();
            tipoEgreso.setId(rs.getInt("id"));
            tipoEgreso.setNombre(rs.getString("nombre"));
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir un TipoEgreso con id " + id, e);
    }
    log.debug("Se consiguio el tipoEgreso " + tipoEgreso);
    return Optional.ofNullable(tipoEgreso);
  }

  @Override
  public Optional<TipoEgreso> getByNombre(String nombre) {
    log.debug("Se intentara conseguir un TipoEgreso con nombre" + nombre);
    TipoEgreso tipoEgreso = null;
    String query = "select * from tipos_egreso where nombre = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setString(1, nombre);
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            tipoEgreso = new TipoEgreso();
            tipoEgreso.setId(rs.getInt("id"));
            tipoEgreso.setNombre(rs.getString("nombre"));
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir un TipoEgreso con nombre " + nombre, e);
    }
    log.debug("Se consigio el TipoEgreso " + tipoEgreso);
    return Optional.ofNullable(tipoEgreso);
  }
}
